import type { InjectionKey, Reactive, Ref } from "vue";
import type { BackUpSetupConfig, EasySetupConfig, ServerInfo, VDevDisk } from "@45drives/houston-common-lib";
import type { SuperSimpleSetupParams, DivisionType } from "@/types";

export const serverInfoInjectionKey: InjectionKey<Reactive<Partial<ServerInfo>>> = Symbol('server-info');
export const globalStorageSetupConfigInjectionKey: InjectionKey<Reactive<EasySetupConfig>> = Symbol('global-config');
export const backUpSetupConfigKey: InjectionKey<Reactive<BackUpSetupConfig>> = Symbol('backup-setup-config');
export const disksInjectionKey: InjectionKey<Reactive<Partial<VDevDisk[]>>> = Symbol('disks-config');
export const paramsKey: InjectionKey<Reactive<SuperSimpleSetupParams>> = Symbol('params');
export const initialHostnameInjectionKey: InjectionKey<Ref<string>> = Symbol('initial-hostname');
export const divisionCodeInjectionKey: InjectionKey<Ref<DivisionType>> = Symbol('division-code');
export const currentWizardInjectionKey: InjectionKey<Ref<'storage' | 'backup' | 'restore-backup' | null>> =
    Symbol('currentWizard');